"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _interopRequireDefault = _interopRequireDefault2(require("@babel/runtime/helpers/interopRequireDefault"));

var _debugLevels = _interopRequireDefault2(require("@resolve-js/debug-levels"));

var _path = _interopRequireDefault2(require("path"));

var _pureRequire = _interopRequireDefault2(require("./pure-require"));

var _liveEntryDir = _interopRequireDefault2(require("./live-entry-dir"));

function _interopRequireDefault2(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const log = (0, _debugLevels.default)('resolve:runtime:liveRequire');

const liveRequire = filePath => {
  const entryPointDirname = (0, _liveEntryDir.default)();
  let resource = null;
  const isRealFilePath = filePath[0] === '/' || filePath[0] === '.';

  if (isRealFilePath && entryPointDirname == null) {
    log.error('Entry point working directory recognition failed');
    return resource;
  }

  const fullPath = isRealFilePath ? _path.default.resolve(entryPointDirname, filePath) : filePath;

  try {
    resource = (0, _interopRequireDefault.default)((0, _pureRequire.default)(fullPath)).default;
  } catch (error) {
    log.error('Live require failed:', error);
  }

  try {
    delete _pureRequire.default.cache[_pureRequire.default.resolve(filePath)];
  } catch (e) {}

  return resource;
};

var _default = liveRequire;
exports.default = _default;
//# sourceMappingURL=live-require.js.map