import { Monitoring, ReadModelInteropMap, SagaInteropMap, SagaInterop, ReadModelInterop, ViewModelInteropMap, ViewModelInterop, Eventstore } from '@resolve-js/core';
export declare type CreateQueryOptions = {
    invokeBuildAsync: Function;
    readModelConnectors: any;
    readModelSources?: any;
    performanceTracer: any;
    getVacantTimeInMillis: any;
    monitoring?: Monitoring;
    readModelsInterop: ReadModelInteropMap | SagaInteropMap;
    viewModelsInterop: ViewModelInteropMap;
    eventstoreAdapter: Eventstore;
    applicationName: string;
};
declare type WrapModelOptions = Omit<Omit<Omit<Omit<CreateQueryOptions, 'readModels'>, 'viewModels'>, 'readModelsInterop'>, 'viewModelsInterop'>;
export declare type WrapReadModelOptions = WrapModelOptions & {
    interop: ReadModelInterop | SagaInterop;
};
export declare type WrapViewModelOptions = WrapModelOptions & {
    interop: ViewModelInterop;
};
export declare type SerializedError = {
    name: string | null;
    code: string | null;
    message: string;
    stack: string;
};
export declare type ReadModelPool = {
    performanceTracer: any;
    isDisposed: boolean;
    connector: any;
    connections: Set<any>;
    invokeBuildAsync: Function;
    getVacantTimeInMillis: Function;
    readModelSource?: any;
    monitoring?: Monitoring;
    eventstoreAdapter: Eventstore;
    applicationName: string;
};
export declare type ViewModelPool = {
    performanceTracer: any;
    isDisposed: boolean;
    monitoring?: Monitoring;
};
export declare type BuildViewModelQuery = {
    aggregateIds: Array<string> | null;
    aggregateArgs: any;
};
export {};
