import { MiddlewareContext, ReadModelInterop, SagaInterop } from '@resolve-js/core';
import { WrapReadModelOptions, ReadModelPool } from './types';
export declare const customReadModelMethods: {
    readonly build: (pool: ReadModelPool, interop: ReadModelInterop | SagaInterop, connection: any, readModelName: string, parameters: {}) => Promise<void>;
    readonly reset: (pool: ReadModelPool, interop: ReadModelInterop | SagaInterop, connection: any, readModelName: string, parameters: {}) => Promise<void>;
    readonly resume: (pool: ReadModelPool, interop: ReadModelInterop | SagaInterop, connection: any, readModelName: string, parameters: {}) => Promise<void>;
    readonly pause: (pool: ReadModelPool, interop: ReadModelInterop | SagaInterop, connection: any, readModelName: string, parameters: {}) => Promise<void>;
    readonly subscribe: (pool: ReadModelPool, interop: ReadModelInterop | SagaInterop, connection: any, readModelName: string, parameters: {
        subscriptionOptions: {
            eventTypes: Array<string> | null;
            aggregateIds: Array<string> | null;
        };
    }) => Promise<void>;
    readonly resubscribe: (pool: ReadModelPool, interop: ReadModelInterop | SagaInterop, connection: any, readModelName: string, parameters: {
        subscriptionOptions: {
            eventTypes: Array<string> | null;
            aggregateIds: Array<string> | null;
        };
    }) => Promise<void>;
    readonly unsubscribe: (pool: ReadModelPool, interop: ReadModelInterop | SagaInterop, connection: any, readModelName: string, parameters: {}) => Promise<void>;
    readonly status: (pool: ReadModelPool, interop: ReadModelInterop | SagaInterop, connection: any, readModelName: string, parameters: {}) => Promise<any>;
};
export declare const checkAllMethodsExist: <T extends object>(obj: T, keys: (keyof T)[]) => boolean;
export declare const checkConnectorMethod: (connector: any) => boolean | null;
declare const wrapReadModel: ({ applicationName, interop, readModelConnectors, invokeBuildAsync, readModelSources, performanceTracer, getVacantTimeInMillis, monitoring, eventstoreAdapter, }: WrapReadModelOptions) => Readonly<{
    serializeState: ({ state }: {
        state: any;
    }) => Promise<string>;
    read: (args_0: any, args_1?: MiddlewareContext | undefined) => Promise<any>;
    dispose: () => Promise<void>;
    deleteProperty: (parameters: {
        key: string;
    }) => Promise<void>;
    getProperty: (parameters: {
        key: string;
    }) => Promise<any>;
    listProperties: (parameters: {}) => Promise<any>;
    setProperty: (parameters: {
        key: string;
        value: any;
    }) => Promise<void>;
}>;
export default wrapReadModel;
